/* notebook: sogou has two modes : compatible mode(ie7) and high speed mode(webkit) 
 *           we should detect which browsing mode the content script running in */

(function com_sogou_YoudaoGouwu () {
    var jsurl = "http://shared.ydstatic.com/gouwuex/ext/script/extension_2_9.js";
    var vendor = "";
    var version = "";
    var optstr = "";
    var av = "2.5";
    var MRE = "";
    var BRE = "";
    var crconf = "";

    (function init() {
        sogouExplorer.extension.sendRequest({type: 'info'}, function(response) {
            vendor = response.vendor;
            version = response.version;
            optstr = response.option;
            MRE = response.matched;
            BRE = response.blocked;
            crconf = response.conf;
            load();
        });
    })();

    function load() {
        var ie = (function() { 
            var v = 3, div = document.createElement('div'), 
            all = div.getElementsByTagName('i'); 
            while (div.innerHTML='<!--[if gt IE '
                + (++v) + ']><i></i><![endif]-->', all[0]); 
            return v > 4 ? v : undefined; 
        })();

        function setOption(opt) {
            sogouExplorer.extension.sendRequest(
                {type: 'setOption', optionstr: opt}, null
            );
        }

        function isShow() {
            if (self != top) {
                return false;
            }
            if (!MRE || !BRE) return false;
            var m = (new RegExp(MRE, 'i')).test(document.location.href);
            var b = (new RegExp(BRE, 'i')).test(document.location.href);
            return m && !b;
        }

        (function () {
            if (!isShow()) return;

            var opnode = document.getElementById('youdaoGWZS_options');
            if (opnode) return;

            var wr = document.createElement("span");
            wr.id = "youdao_gouwu";
            wr.style.display = 'none';

            var conf = document.createElement("span");
            conf.id = "youdaoGWZS_config";
            conf.innerText = encodeURIComponent(crconf);
            wr.appendChild(conf);

            opnode = document.createElement('span');
            opnode.id = 'youdaoGWZS_options';
            wr.appendChild(opnode);
            document.getElementsByTagName('body')[0].appendChild(wr);

            opnode.innerText = optstr;
            if (ie === undefined) {
                opnode.firstChild.addEventListener(
                    'DOMCharacterDataModified', function() {
                        var opts = this.parentElement.innerText;
                        sogouExplorer.extension.sendRequest({
                            type: 'setOptions', optionstr: opts
                        });
                    }, false);
            } else {
                opnode.innerHTML += ';state=normal;featureCode=1111111;isDiscountOpen=close';
            }
            var jsnode = document.createElement('script');
            jsnode.charset = 'UTF-8';
            jsnode.type = 'text/javascript';
            jsnode.id = 'youdao_gouwu_assistant';
            jsnode.src = jsurl + '?browser=sogou' 
                + '&version=' + version + '&vendor=' + vendor;
            document.getElementsByTagName('head')[0].appendChild(jsnode);
        })();
    };
})();
