var g_logUrlPrefix = "http://zhushou.huihui.cn/log?";
var g_vendor;
var g_version;

var searchTip = '\u8bf7\u8f93\u5165\u60f3\u67e5\u627e\u7684\u5546\u54c1';
var searchBox;
window.addEventListener('DOMContentLoaded', function() {
    document.querySelector('#searchbox').addEventListener('submit', onSearch);
    document.querySelector('#disc').addEventListener('click', onDiscount);
    document.querySelector('#logo').addEventListener('click', onLogo);
    document.querySelector('#fb').addEventListener('click', onSuggest);
    document.querySelector('#help').addEventListener('click', onHelp);

    g_vendor = localStorage['vendor'];
    g_version = 2.6;
    searchBox = document.getElementById('searchbox');
    searchBox.value = searchTip;
    browserActionTriggered();
    searchBox.addEventListener('focus', function() {
        if (searchBox.value === searchTip) {
            searchBox.value = '';
            searchBox.style.color = 'black';
        }
        searchBox.style.borderColor = '#F9BE52';
    }, false);
    searchBox.addEventListener('blur', function() {
        if (searchBox.value === '') {
            searchBox.value = searchTip;
            searchBox.style.color = '#CCC';
        }
    }, false);
}, false);

function browserActionTriggered() {
    sendLog('ACTION', 'CLICK_BUTTON');
}

function blink() {
    var counter = 0;
    var colorArr = ['#F9BE52', '#BABABA'];
    var timer = setInterval(function() {
        searchBox.style.borderColor = colorArr[counter % colorArr.length];
        counter++;
        if (counter > 7) {
            searchBox.style.removeProperty('border-color');
            clearInterval(timer);
        }
    },
    100);
}

function sendLog(type, action) {
    var logUrl = g_logUrlPrefix;
    if (type == 'INSTALL') {
        logUrl += 'type=ARMANI_EXTENSION_INSTALL' + '&' + 
            'version=' + g_version + '&' + 
            'vendor=' + g_vendor + '&' + 
            'browser=sogou';
    } else if (type == 'ACTION') {
        logUrl += 'type=ARMANI_EXTENSION_ACTION' + '&' + 
            'action=' + action + '&' + 
            'version=' + g_version + '&' + 
            'vendor=' + g_vendor + '&' + 
            'browser=sogou';
    }
    var xhr = new XMLHttpRequest();
    xhr.open('GET', logUrl, true);
    xhr.send();
}

function onSearch() {
    if (searchBox.value === searchTip) { 
        blink();
        return false;
    } else {
        sendLog('ACTION', 'SEARCH_BUTTON');
        window.close();
        return true;
    }
}

function onHelp() {
    sendLog('ACTION', 'HELP_BUTTON');
    var url = "http://zhushou.huihui.cn/features?keyfrom=extension_button";
    sogouExplorer.tabs.create({'url': url, 'selected': true});
    window.close();
    return true;
}

function onSuggest() {
    sendLog('ACTION', 'SUGGEST_BUTTON');
    var url = "http://zhushou.huihui.cn/suggest";
    sogouExplorer.tabs.create({'url': url, 'selected': true});
    window.close();
    return true;
}

function onLogo() {
    sendLog('ACTION', 'CLICK_LOGO_BUTTON');
    var url = "http://www.huihui.cn/?keyfrom=extension_button";
    sogouExplorer.tabs.create({'url': url, 'selected': true});
    window.close();
    return true;
}

function onDiscount() {
    sendLog('ACTION', 'CLICK_DISCOUNT_BUTTON');
    var url = 'http://www.huihui.cn/deals?keyfrom=extension';
    sogouExplorer.tabs.create({'url': url, 'selected': true});
    window.close();
    return true;
}
